/*
    w32loader
    copyright (c) 1998-2007 Kazuki IWAMOTO http://www.maid.org/ iwm@maid.org

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
#include "commdlg.h"


#ifdef W32LDR_HEADER
#include "gdi32.h"

#define CF_SCREENFONTS          0x00000001
#define CF_PRINTERFONTS         0x00000002
#define CF_BOTH                 (CF_SCREENFONTS|CF_PRINTERFONTS)
#define CF_SHOWHELP             0x00000004
#define CF_ENABLEHOOK           0x00000008
#define CF_ENABLETEMPLATE       0x00000010
#define CF_ENABLETEMPLATEHANDLE 0x00000020
#define CF_INITTOLOGFONTSTRUCT  0x00000040
#define CF_USESTYLE             0x00000080
#define CF_EFFECTS              0x00000100
#define CF_APPLY                0x00000200
#define CF_ANSIONLY             0x00000400
#define CF_SCRIPTSONLY          CF_ANSIONLY
#define CF_NOVECTORFONTS        0x00000800
#define CF_NOOEMFONTS           CF_NOVECTORFONTS
#define CF_NOSIMULATIONS        0x00001000
#define CF_LIMITSIZE            0x00002000
#define CF_FIXEDPITCHONLY       0x00004000
#define CF_WYSIWYG              0x00008000
#define CF_FORCEFONTEXIST       0x00010000
#define CF_SCALABLEONLY         0x00020000
#define CF_TTONLY               0x00040000
#define CF_NOFACESEL            0x00080000
#define CF_NOSTYLESEL           0x00100000
#define CF_NOSIZESEL            0x00200000
#define CF_SELECTSCRIPT         0x00400000
#define CF_NOSCRIPTSEL          0x00800000
#define CF_NOVERTFONTS          0x01000000
#define SIMULATED_FONTTYPE      0x8000
#define PRINTER_FONTTYPE        0x4000
#define SCREEN_FONTTYPE         0x2000
typedef UINT (CALLBACK *LPCFHOOKPROC)(HWND, UINT, WPARAM, LPARAM);
#include "pshpack1.h"
typedef struct _CHOOSEFONTA
{
  UINT lStructSize;
  HWND hwndOwner;
  HDC hDC;
  LPLOGFONTA lpLogFont;
  INT iPointSize;
  DWORD Flags;
  COLORREF rgbColors;
  LPARAM lCustData;
  LPCFHOOKPROC lpfnHook;
  LPCSTR lpTemplateName;
  HINSTANCE hInstance;
  LPSTR lpszStyle;
  WORD nFontType;
  WORD ___MISSING_ALIGNMENT__;
  INT nSizeMin;
  INT nSizeMax;
} CHOOSEFONTA, *PCHOOSEFONTA, *LPCHOOSEFONTA;
typedef struct _CHOOSEFONTW
{
  UINT lStructSize;
  HWND hwndOwner;
  HDC hDC;
  LPLOGFONTW lpLogFont;
  INT iPointSize;
  DWORD Flags;
  COLORREF rgbColors;
  LPARAM lCustData;
  LPCFHOOKPROC lpfnHook;
  LPCWSTR lpTemplateName;
  HINSTANCE hInstance;
  LPWSTR lpszStyle;
  WORD nFontType;
  WORD ___MISSING_ALIGNMENT__;
  INT nSizeMin;
  INT nSizeMax;
} CHOOSEFONTW, *PCHOOSEFONTW, *LPCHOOSEFONTW;
#include "poppack.h"
#ifdef UNICODE
# define CHOOSEFONT CHOOSEFONTW
# define PCHOOSEFONT PCHOOSEFONTW
# define LPCHOOSEFONT LPCHOOSEFONTW
#else /* not UNICODE */
# define CHOOSEFONT CHOOSEFONTA
# define PCHOOSEFONT PCHOOSEFONTA
# define LPCHOOSEFONT LPCHOOSEFONTA
#endif /* not UNICODE */

#define OFN_READONLY             0x00000001
#define OFN_OVERWRITEPROMPT      0x00000002
#define OFN_HIDEREADONLY         0x00000004
#define OFN_NOCHANGEDIR          0x00000008
#define OFN_SHOWHELP             0x00000010
#define OFN_ENABLEHOOK           0x00000020
#define OFN_ENABLETEMPLATE       0x00000040
#define OFN_ENABLETEMPLATEHANDLE 0x00000080
#define OFN_NOVALIDATE           0x00000100
#define OFN_ALLOWMULTISELECT     0x00000200
#define OFN_EXTENSIONDIFFERENT   0x00000400
#define OFN_PATHMUSTEXIST        0x00000800
#define OFN_FILEMUSTEXIST        0x00001000
#define OFN_CREATEPROMPT         0x00002000
#define OFN_SHAREAWARE           0x00004000
#define OFN_NOREADONLYRETURN     0x00008000
#define OFN_NOTESTFILECREATE     0x00010000
#define OFN_NONETWORKBUTTON      0x00020000
#define OFN_NOLONGNAMES          0x00040000
#define OFN_SHAREFALLTHROUGH     2
#define OFN_SHARENOWARN          1
#define OFN_SHAREWARN            0
typedef UINT (CALLBACK *LPOFNHOOKPROC)(HWND, UINT, WPARAM, LPARAM);
typedef struct _OPENFILENAMEA
{
  DWORD lStructSize;
  HWND hwndOwner;
  HINSTANCE hInstance;
  LPCSTR lpstrFilter;
  LPSTR lpstrCustomFilter;
  DWORD nMaxCustFilter;
  DWORD nFilterIndex;
  LPSTR lpstrFile;
  DWORD nMaxFile;
  LPSTR lpstrFileTitle;
  DWORD nMaxFileTitle;
  LPCSTR lpstrInitialDir;
  LPCSTR lpstrTitle;
  DWORD Flags;
  WORD nFileOffset;
  WORD nFileExtension;
  LPCSTR lpstrDefExt;
  LPARAM lCustData;
  LPOFNHOOKPROC lpfnHook;
  LPCSTR lpTemplateName;
} OPENFILENAMEA, *POPENFILENAMEA, *LPOPENFILENAMEA;
typedef struct _OPENFILENAMEW
{
  DWORD lStructSize;
  HWND hwndOwner;
  HINSTANCE hInstance;
  LPCWSTR lpstrFilter;
  LPWSTR lpstrCustomFilter;
  DWORD nMaxCustFilter;
  DWORD nFilterIndex;
  LPWSTR lpstrFile;
  DWORD nMaxFile;
  LPWSTR lpstrFileTitle;
  DWORD nMaxFileTitle;
  LPCWSTR lpstrInitialDir;
  LPCWSTR lpstrTitle;
  DWORD Flags;
  WORD nFileOffset;
  WORD nFileExtension;
  LPCWSTR lpstrDefExt;
  LPARAM lCustData;
  LPOFNHOOKPROC lpfnHook;
  LPCWSTR lpTemplateName;
} OPENFILENAMEW, *POPENFILENAMEW, *LPOPENFILENAMEW;
#ifdef UNICODE
# define OPENFILENAME OPENFILENAMEW
# define POPENFILENAME POPENFILENAMEW
# define LPOPENFILENAME LPOPENFILENAMEW
#else /* not UNICODE */
# define OPENFILENAME OPENFILENAMEA
# define POPENFILENAME POPENFILENAMEA
# define LPOPENFILENAME LPOPENFILENAMEA
#endif /* not UNICODE */
#endif /* W32LDR_HEADER */


/* ChooseColorA ordinal = 101, argument = 4 temporary */
static DWORD WINAPI ChooseColorA (DWORD dwArgv0)
{
  return 0;
}


/* ChooseColorW ordinal = 102, argument = 4 temporary */
static DWORD WINAPI ChooseColorW (DWORD dwArgv0)
{
  return 0;
}


/* ChooseFontA ordinal = 103, argument = 4 temporary */
static DWORD WINAPI ChooseFontA (DWORD dwArgv0)
{
  return 0;
}


/* ChooseFontW ordinal = 104, argument = 4 temporary */
static DWORD WINAPI ChooseFontW (DWORD dwArgv0)
{
  return 0;
}


/* CommDlgExtendedError ordinal = 105, argument = 0 temporary */
static DWORD WINAPI CommDlgExtendedError (VOID)
{
  return 0;
}


/* FindTextA ordinal = 106, argument = 4 temporary */
static DWORD WINAPI FindTextA (DWORD dwArgv0)
{
  return 0;
}


/* FindTextW ordinal = 107, argument = 4 temporary */
static DWORD WINAPI FindTextW (DWORD dwArgv0)
{
  return 0;
}


/* GetFileTitleA ordinal = 108, argument = 12 temporary */
static DWORD WINAPI GetFileTitleA (DWORD dwArgv0, DWORD dwArgv1, DWORD dwArgv2)
{
  return 0;
}


/* GetFileTitleW ordinal = 109, argument = 12 temporary */
static DWORD WINAPI GetFileTitleW (DWORD dwArgv0, DWORD dwArgv1, DWORD dwArgv2)
{
  return 0;
}


/* GetOpenFileNameA ordinal = 110, argument = 4 temporary */
static DWORD WINAPI GetOpenFileNameA (DWORD dwArgv0)
{
  return 0;
}


/* GetOpenFileNameW ordinal = 111, argument = 4 temporary */
static DWORD WINAPI GetOpenFileNameW (DWORD dwArgv0)
{
  return 0;
}


/* GetSaveFileNameA ordinal = 112, argument = 4 temporary */
static DWORD WINAPI GetSaveFileNameA (DWORD dwArgv0)
{
  return 0;
}


/* GetSaveFileNameW ordinal = 113, argument = 4 temporary */
static DWORD WINAPI GetSaveFileNameW (DWORD dwArgv0)
{
  return 0;
}


/* LoadAlterBitmap ordinal = 114, argument = 12 temporary */
static DWORD WINAPI LoadAlterBitmap (DWORD dwArgv0, DWORD dwArgv1, DWORD dwArgv2)
{
  return 0;
}


/* PageSetupDlgA ordinal = 115, argument = 4 temporary */
static DWORD WINAPI PageSetupDlgA (DWORD dwArgv0)
{
  return 0;
}


/* PageSetupDlgW ordinal = 116, argument = 4 temporary */
static DWORD WINAPI PageSetupDlgW (DWORD dwArgv0)
{
  return 0;
}


/* PrintDlgA ordinal = 117, argument = 4 temporary */
static DWORD WINAPI PrintDlgA (DWORD dwArgv0)
{
  return 0;
}


/* PrintDlgExA ordinal = 118, argument = 4 temporary */
static DWORD WINAPI PrintDlgExA (DWORD dwArgv0)
{
  return 0;
}


/* PrintDlgExW ordinal = 119, argument = 4 temporary */
static DWORD WINAPI PrintDlgExW (DWORD dwArgv0)
{
  return 0;
}


/* PrintDlgW ordinal = 120, argument = 4 temporary */
static DWORD WINAPI PrintDlgW (DWORD dwArgv0)
{
  return 0;
}


/* ReplaceTextA ordinal = 121, argument = 4 temporary */
static DWORD WINAPI ReplaceTextA (DWORD dwArgv0)
{
  return 0;
}


/* ReplaceTextW ordinal = 122, argument = 4 temporary */
static DWORD WINAPI ReplaceTextW (DWORD dwArgv0)
{
  return 0;
}


/* Ssync_ANSI_UNICODE_Struct_For_WOW ordinal = 123, argument = 12 temporary */
static DWORD WINAPI Ssync_ANSI_UNICODE_Struct_For_WOW (DWORD dwArgv0, DWORD dwArgv1, DWORD dwArgv2)
{
  return 0;
}


/* WantArrows ordinal = 124, argument = 16 temporary */
static DWORD WINAPI WantArrows (DWORD dwArgv0, DWORD dwArgv1, DWORD dwArgv2, DWORD dwArgv3)
{
  return 0;
}


/* dwLBSubclass ordinal = 125, argument = 16 temporary */
static DWORD WINAPI dwLBSubclass (DWORD dwArgv0, DWORD dwArgv1, DWORD dwArgv2, DWORD dwArgv3)
{
  return 0;
}


/* dwOKSubclass ordinal = 126, argument = 16 temporary */
static DWORD WINAPI dwOKSubclass (DWORD dwArgv0, DWORD dwArgv1, DWORD dwArgv2, DWORD dwArgv3)
{
  return 0;
}


W32LdrExport commdlg_exports[] = {
{FALSE, 101, "ChooseColorA",                      ChooseColorA},
{FALSE, 102, "ChooseColorW",                      ChooseColorW},
{FALSE, 103, "ChooseFontA",                       ChooseFontA},
{FALSE, 104, "ChooseFontW",                       ChooseFontW},
{FALSE, 105, "CommDlgExtendedError",              CommDlgExtendedError},
{FALSE, 106, "FindTextA",                         FindTextA},
{FALSE, 107, "FindTextW",                         FindTextW},
{FALSE, 108, "GetFileTitleA",                     GetFileTitleA},
{FALSE, 109, "GetFileTitleW",                     GetFileTitleW},
{FALSE, 110, "GetOpenFileNameA",                  GetOpenFileNameA},
{FALSE, 111, "GetOpenFileNameW",                  GetOpenFileNameW},
{FALSE, 112, "GetSaveFileNameA",                  GetSaveFileNameA},
{FALSE, 113, "GetSaveFileNameW",                  GetSaveFileNameW},
{FALSE, 114, "LoadAlterBitmap",                   LoadAlterBitmap},
{FALSE, 115, "PageSetupDlgA",                     PageSetupDlgA},
{FALSE, 116, "PageSetupDlgW",                     PageSetupDlgW},
{FALSE, 117, "PrintDlgA",                         PrintDlgA},
{FALSE, 118, "PrintDlgExA",                       PrintDlgExA},
{FALSE, 119, "PrintDlgExW",                       PrintDlgExW},
{FALSE, 120, "PrintDlgW",                         PrintDlgW},
{FALSE, 121, "ReplaceTextA",                      ReplaceTextA},
{FALSE, 122, "ReplaceTextW",                      ReplaceTextW},
{FALSE, 123, "Ssync_ANSI_UNICODE_Struct_For_WOW", Ssync_ANSI_UNICODE_Struct_For_WOW},
{FALSE, 124, "WantArrows",                        WantArrows},
{FALSE, 125, "dwLBSubclass",                      dwLBSubclass},
{FALSE, 126, "dwOKSubclass",                      dwOKSubclass},
{FALSE, 0, NULL, NULL}};
